/*******************************************************************************
GetPosABS by Faguss (ofp-faguss.com) 23.08.14
Uses code from getpos2.sqf function by toadlife

Usage: 	
	<object> call preProcessFile "getPosABS.sqf"
	[<object>,<optional measurement method>] call preProcessFile "getPosABS.sqf"
		
Example:
	player call preProcessFile "getPosABS.sqf"
	[player, "logic"] call preProcessFile "getPosABS.sqf"
	
Second argument is the class name of the object that is used
to measure absolute height. By default it's "emptyDetector"
(distance from sea level).
Alternative is "logic" (distance from the ground).
	
*******************************************************************************/


private ["_trigger", "_unit", "_class", "_pos"];
_class = "emptyDetector";
_unit = _this;


if (!(_this in [_this])) then
{
	_unit = _this select 0;
	if (count _this > 1) then {_class=_this select 1}
};

_pos = getPos _unit;

_trigger = _class camCreate [0,0,0];
_trigger setPos _pos;
_pos set [2, (_pos select 2) + (_unit distance _trigger)];
camDestroy _trigger;


_pos