/************************************************************************************************************************
SetPosABS by Faguss (ofp-faguss.com) 23.08.14
Uses code from getpos2.sqf function by toadlife

Usage: 	
	[<object>, <position array or just wanted height>, <optional measurement method>] call preProcessFile "setPosABS.sqf"
	
Example:
	[player, [_x,_y,_z]] call preProcessFile "setPosABS.sqf"
	[player, 30] call preProcessFile "setPosABS.sqf"
	[player, 30, "logic"] call preProcessFile "setPosABS.sqf"
	
Output:
	Returns position with relative height
	
Third argument is the class name of the object that is used
to measure absolute height. By default it's "emptyDetector"
(distance from sea level).
Alternative is "logic" (distance from the ground).
	
************************************************************************************************************************/


private ["_unit", "_pos", "_class", "_trigger"];

_unit = _this select 0;
_pos = _this select 1;
_class = "emptyDetector";

// Passed [unit, _z]	
if (_pos in [_pos]) then
{
	_pos = getPos _unit;
	_pos set [2, _this select 1]
};

if (count _this > 2) then {_class=_this select 2};

	
// Change position
_unit setPos _pos;


// Get absolute height
_trigger = _class camCreate [0,0,0];
_trigger setPos (getPos _unit);
_pos set [2, (_pos select 2) + (_pos select 2) - ((getPos _unit select 2) + (_unit distance _trigger))];
camDestroy _trigger;


// Find difference between wanted and current position
_pos set [0, (_pos select 0) - ((getpos _unit select 0) - (_pos select 0))];
_pos set [1, (_pos select 1) - ((getpos _unit select 1) - (_pos select 1))];


// Apply correction
_unit setPos _pos;

_pos
